﻿Enumeration
  
  #ot
  #re
  #ma
  #fl1;   #PB_RegularExpression_DotAll    : '.' matches anything including newlines.
  #fl2;   #PB_RegularExpression_Extended  : whitespace And '#' comments will be ignored.
  #fl3;   #PB_RegularExpression_MultiLine : '^' And '$' match newlines within Data.
  #fl4;   #PB_RegularExpression_AnyNewLine: recognize 'CR', 'LF', And 'CRLF' As newline sequences.
  #fl5;   #PB_RegularExpression_NoCase    : comparison And matching will be Case-insensitive
EndEnumeration

Procedure testre()
  Static Dim Match.s(0)
  SetGadgetText(#ma,"")
  re$=GetGadgetText(#re)
  If re$<>""
    fl.l=0
    fl=fl|(GetGadgetState(#fl1)*#PB_RegularExpression_DotAll);    : '.' matches anything including newlines.
    fl=fl|(GetGadgetState(#fl2)*#PB_RegularExpression_Extended);  : whitespace And '#' comments will be ignored.
    fl=fl|(GetGadgetState(#fl3)*#PB_RegularExpression_MultiLine); : '^' And '$' match newlines within Data.
    fl=fl|(GetGadgetState(#fl4)*#PB_RegularExpression_AnyNewLine);: recognize 'CR', 'LF', And 'CRLF' As newline sequences.
    fl=fl|(GetGadgetState(#fl5)*#PB_RegularExpression_NoCase)    ;    : comparison And matching will be Case-insensitive
    
    If CreateRegularExpression(0,re$,fl)
      
      Matches.l = ExtractRegularExpression(0, GetGadgetText(#ot), Match())
      If Matches > 0
        For i = 0 To Matches - 1
          AddGadgetItem(#ma, -1, Match(i))
        Next i
      EndIf
      FreeRegularExpression(0)
    Else
      SetGadgetText(#ma,RegularExpressionError())

    EndIf;CreateRegularExpression(0,re$,fl)
  EndIf  ;re$<>""
EndProcedure

If OpenWindow(0, 0, 0, 640, 480, "RegExTester", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  EditorGadget(#ot, 0, 0, 640, 220, #PB_Editor_WordWrap):GadgetToolTip(#ot,"test text")
  StringGadget(#re,0,220,640,20,""):GadgetToolTip(#re,"type regexp")
  
  CheckBoxGadget(#fl1,0,240,40,20,"."):GadgetToolTip(#fl1,"'.' matches anything including newlines")
  CheckBoxGadget(#fl2,40,240,40,20,"#"):GadgetToolTip(#fl2,"whitespace And '#' comments will be ignored.")
  CheckBoxGadget(#fl3,80,240,40,20,"$^"):GadgetToolTip(#fl3,"'^' And '$' match newlines within Data.")
  CheckBoxGadget(#fl4,120,240,40,20,"crlf"):GadgetToolTip(#fl4,"recognize 'CR', 'LF', And 'CRLF' As newline sequences.")
  CheckBoxGadget(#fl5,160,240,40,20,"Aa"):GadgetToolTip(#fl5,"comparison And matching will be Case-insensitive")
  
  EditorGadget(#ma, 0, 260, 640, 220, #PB_Editor_ReadOnly):GadgetToolTip(#ma,"matches")
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE) & $8000;=-32767
      Break
    EndIf
    Select Event
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #fl1,#fl2,#fl3,#fl4,#fl5
            testre()
          Case #re
            If EventType()=#PB_EventType_Change
              testre()
            EndIf
          Case #ot
            If EventType()=#PB_EventType_Change
              testre()
            EndIf
        EndSelect
        
        
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf


; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 34
; FirstLine = 4
; Folding = -
; EnableXP
; UseIcon = retest.ico
; Executable = retest.exe